<? session_start();
   // я устанавливаю здесь тестовые данные
   $_SESSION['user'] = array(
     'id'=>1,
     'avatar'=>'img/1.png',
     'fname'=>'Дмитрий Намаев'
   );
?>
<!DOCTYPE HTML>
<html>
<head>
	<meta http-equiv="content-type" content="text/html" />
	<meta name="author" content="Sasha_des" />
    <script type="text/javascript" src="js/jquery.v1.11.0.min.js"></script>
    <title>Chat</title>
</head>
<style type="text/css">
    body {
        background:#fafafa !important;
        width:100%; height:100%; margin:0;
    }
    #box {
        width:60%;
        height:auto;
        display:block;
        background:#fff;
        border:1px solid #eee;
        margin:2% auto;
    }
    #showMore {
        display:block;
        width:40%;
        height:30px;
        font: normal normal 400 16px/26px "Segoe UI";
        color:#fff;
        padding-top:0px;
        margin:20px 0 25px 20px;
        background:#aaa;
        border:1px solid #aaa;
        border-radius:2px;
        outline:none;
    }
    #showMore:hover {
        background:#477bea; border-color:#477bea;
        cursor:pointer;
    }
    #chatForm {
        display:block;
        width:80%;
        height:100px;
        margin:20px 0 20px 20px;
    }
    #chatForm > textarea {
        width:98%;
        height:50px;
        background:#fff;
        color:#333;
        border:1px solid #ddd;
        padding:1%;
        margin:0 0 10px 0;   
    }
    #chatForm > input {
        display:block;
        width:100px;
        height:25px;
        font: normal normal 400 14px/18px "Segoe UI";
        color:#fff;
        padding-top:0px;
        background:#f60;
        border:1px solid #f60;
        border-radius:2px;
        outline:none;
        float:right; margin-right:-2px;
    }
    #chatForm > input:hover {
        background:#f50; border-color:#f50;
        cursor:pointer;
    }
    #chatList {
        width:80%;
        height:auto;
        display:block;
        margin:0 0 0 20px;
    }
    .chatComm {
        width:100%;
        height:auto;
        display:block;
        margin:0;
        position:relative;
    }
    .chatComm > img {
        width:50px;
        height:50px;
        border-radius: 25px;
        background:#777;
    }
    .chatComm > span:nth-child(2) {
        display:block;
        font: normal normal 400 14px/18px "Segoe UI";
        color:#477bea;
        position:absolute;
        top:0; left:60px;
    }
    .chatComm > span:nth-child(3) {
        display:block;
        width:300px;
        text-align:right;
        font: normal normal 400 12px/18px "Segoe UI";
        color:#999;
        position:absolute;
        top:0; left:100%; margin-left:-300px;
    }
    .chatComm > p {
        font: normal normal 400 14px/22px "Segoe UI";
        color:#333;
        position:relative;
        top:-40px; left:60px;
        padding-right:60px;
        display:block; height:auto;
        margin-bottom:-20px; 
    }
    
</style>
<body>
    <div id="box">
        <input type="button" id="showMore" value="Показать старую переписку" />
        
        <div id="chatList">
                        
        </div>
        
        <form id="chatForm">
            <textarea name="text"></textarea>
            <input type="submit" value="Добавить" />
        </form>
    </div>
    <script type="text/javascript">
        $(function(){
            var set = {
                avatar:'<?=$_SESSION['user']['avatar']?>',
                name:'<?=$_SESSION['user']['fname']?>',
                users:[]
            }
            set.users[parseInt(<?=$_SESSION['user']['id']?>)]=['<?=$_SESSION['user']['avatar']?>','<?=$_SESSION['user']['fname']?>'];
            
            // загрузка начального списка сообщений
            $.ajax({
                type: "POST",
                dataType: "json",
                data: "type=get",
                beforeSend: function(x) {if(x && x.overrideMimeType) {x.overrideMimeType("application/json;charset=UTF-8");}},
                url:'server.php',
                success: function(data) {
                    if(data && data.length>0){
                        for(var i=0,c=data.length;i<c;i++){
                            if(typeof set.users[parseInt(data[i].user_id)]=='undefined'){
                                $.ajax({
                                    type: "POST", dataType: "json", url:'server.php',async:false,
                                    data: "type=user&user_id="+data[i].user_id,
                                    success: function(e) {
                                        set.users[parseInt(e[0].id)]=[e[0].avatar,e[0].fname];
                                        console.log(set.users);
                                    }
                                });
                            }
                            $('<div class="chatComm" id="'+data[i].id+'msg"><img src="'+set.users[parseInt(data[i].user_id)][0]+'" /><span>'+set.users[parseInt(data[i].user_id)][1]+'</span><span>'+data[i].date+'</span><p>'+data[i].text+'</p></div>').appendTo('#chatList');
                        }
                    }
                }
            });
            
            
            // отправка сообщения
            $('#chatForm').submit(function(e){
                e.preventDefault();
                var text = $.trim($(this).children('textarea').val());
                if(text){
                    $.ajax({
                        type: "POST",
                        url:"server.php",
                        data:({
                            text:text,
                            type:'add'
                        }),
                        dataType:"html",
                        async:false,
                        success:function(e){
                            if(e){
                                e = e.split('|');
                                $('<div class="chatComm" id="'+e[0]+'msg"><img src="'+set.avatar+'" /><span>'+set.name+'</span><span>'+e[1]+'</span><p>'+text+'</p></div>').appendTo('#chatList');
                                $('#chatForm').children('textarea').val('');
                            }
                        }
                    }).responseText;
                }
            });
            
            $('#showMore').click(function(){
                var p = parseInt($('.chatComm:first').attr('id'));
                $.ajax({
                    type: "POST",
                    dataType: "json",
                    data: "type=getExt&p="+p,
                    beforeSend: function(x) {if(x && x.overrideMimeType) {x.overrideMimeType("application/json;charset=UTF-8");}},
                    url:'server.php',
                    success: function(data) {
                        if(data.list && data.list.length>0){
                            if(typeof data.c!=='undefined' && data.c==false){
                                $('#showMore').fadeOut(100,function(){ 
                                    $(this).remove();
                                    $('#chatList').css('marginTop',20);
                                 });
                            }
                            for(var i=0,c=data.list.length;i<c;i++){
                                if(typeof set.users[parseInt(data.list[i].user_id)]=='undefined'){
                                    $.ajax({
                                        type: "POST", dataType: "json", url:'server.php',async:false,
                                        data: "type=user&user_id="+data.list[i].user_id,
                                        success: function(e) {
                                            set.users[parseInt(e[0].id)]=[e[0].avatar,e[0].fname];
                                        }
                                    });
                                }
                                $('<div class="chatComm" id="'+data.list[i].id+'msg"><img src="'+set.users[parseInt(data.list[i].user_id)][0]+'" /><span>'+set.users[parseInt(data.list[i].user_id)][1]+'</span><span>'+data.list[i].date+'</span><p>'+data.list[i].text+'</p></div>').prependTo('#chatList');
                            }
                        }
                    }
                });
            });
        });
    </script>
</body>
</html>