<?
edit_title('Чат');
$stars = stars($db);
?>

<style type="text/css">
	.content{width:433px !important;}
    #box {
        width:99%;
        height:auto;
        display:block;
        margin:2% auto;
    }
    #showMore {
        display:block;
        width:40%;
        height:30px;
        font: normal normal 400 16px/26px "Segoe UI";
        color:#fff;
        padding-top:0px;
        margin:20px 0 25px 20px;
        background:#aaa;
        border:1px solid #aaa;
        border-radius:2px;
        outline:none;
    }
    #showMore:hover {
        background:#477bea; border-color:#477bea;
        cursor:pointer;
    }
    #chatForm {
        display: block;
		width: 94.7%;
		height: 100px;
		margin: 20px 0px 20px 13px;
    }
    #chatForm > textarea {
        width:98%;
        height:50px;
        background:#fff;
        color:#333;
        border:1px solid #ddd;
        padding:1%;
        margin:0 0 10px 0;   
    }
   #chatForm > .input {
	display: block;
	width: 98px;
	height: 31px;
	font: normal normal 400 14px/18px "Segoe UI";
	color: #fff;
	padding-top: 0px;
	background: #C65000;
	border: 1px solid #C65000;
	border-radius: 2px;
	outline: none;
	float: right;
	margin-right: -2px;
	padding-top: 5px;
	}
    #chatForm > .input:hover {
        background:#774320; border-color:#774320;
        cursor:pointer;
    }
	#chatForm > .input:active {
		background: #F30;
		border-color: #FF1500;
	}
	#chatForm > .input[disabled=disabled] {
		background: gray;
		border-color: gray;
	}
    .chatComm {
        width:100%;
        height:auto;
        display:block;
        margin:0;
        position:relative;
    }
    .chatComm > img {
        width:50px;
        height:50px;
        border-radius: 25px;
        background:#777;
    }
    .chatComm > span:nth-child(2) {
        display:block;
        font: normal normal 400 14px/18px "Segoe UI";
        color:#477bea;
        position:absolute;
        top:0; left:60px;
    }
    .chatComm > span:nth-child(3) {
        display:block;
        width:300px;
        text-align:right;
        font: normal normal 400 12px/18px "Segoe UI";
        color:#999;
        position:absolute;
        top:0; left:100%; margin-left:-300px;
    }
    .chatComm > p {
        font: normal normal 400 14px/22px "Segoe UI";
        color:#333;
        position:relative;
        top:-40px; left:60px;
        padding-right:60px;
        display:block; height:auto;
        margin-bottom:-20px; 
    }
    #chatList {
        width:76.2%;
		float: left;
        height:auto;
        display:block;
        margin:0 0 0 8px;
    }
	 #chatList.bottom {
		  width:96.5%;
	 }
	#chatList .message{min-height:20px;border:none;border-radius:3px;background:rgba(119,67,32,1);padding:5px 7px;margin:2px 4px;word-break: break-all;}
	#chatList .message:hover {
		border-radius: 4px;
		background:rgba(150, 85, 42, 1);
	}
	#chatList .message span.date{font-size:16px;color:#00E1FA;}
	#chatList .message span.date.old{color:#FA5800;}
	#chatList .message span.user{color:#F0EB7B;}
	#chatList .message span.user.adm,#whoOnlineList a.adm{margin:2px 0px;color: rgb(255, 255, 255);padding: 1px 2px;background: rgb(0, 0, 0);border-radius: 3px;}
	#chatList .message span.user.i,#whoOnlineList a.i{margin:2px 0px;color: rgb(255, 255, 255);padding: 1px 2px;background: rgb(23, 72, 193);border-radius: 3px;}
	#chatList .message span.text{color:#ffffff;}
	#onlineList{
		font-size: 21px;
		text-align: center;
		padding: 5px 7px;
		border-radius: 3px;
		background:rgba(119,67,32,1);
		color: white;
		width: 17.5%;
		min-height: 125px;
		float: left;
		display: block;
		margin: 2px 0 4px 2px;
    }
	#whoOnlineList{
		font-size: 18px;
		padding:3px;
		color:#F0EB7B;
		text-align:left;
		border-top:1px dotted #F0F056;
	}
	#whoOnlineList li{
		list-style-type:none;
		padding:3px;
	}
	#whoOnlineList li a{
		color:#F0EB7B;
		padding:4px;
		text-decoration:none;
	}
	input.success{
		border-color:rgb(0,189,0) !important;
		background:rgb(0,189,0) !important;
	}
	input.success2{
		border:2px solid rgb(0,189,0) !important;
	}
	input.fail {
		border-color: rgb(192,53,0) !important;
		background: rgb(226,1,0) !important;
	}
	input.fail2{
		border:2px solid rgb(192,53,0) !important;
	}
	#inputChat{
		color: gray;
		outline: none;
		padding:7px;
		width:74%;
		border:2px solid #F67118;
		border-radius:3px;
		background:rgba(256,256,256,0.9);
	}
	#inputChat:active {
		outline: none;
		border-color:green;
	}
	#inputChat:focus { outline: none;border-color: #FF1500; }
	#smileBlock {
		position: absolute;
		width: 420px;
		height: 200px;
		padding: 5px;
		margin: -247px 0 0 170px;
		background: #FFF;
		border-radius: 3px;
		vertical-align: middle;
		overflow: auto;
		box-shadow: 0 0 3px 2px rgba(77,19,5,.2);
		z-index: 999;
		display: none;
	}
	#smileBlock img{
		padding:4px;
		border-radius:3px;
	}
	#smileBlock img:hover{
		background:#89AFBF;
	}
	#smile:hover {
		opacity: 0.9;
		z-index: 998;
	}
	#smile {
		position: absolute;
		margin: 3px 0px 0px -31px;
		width: 27px;
		opacity: 0.5;
		cursor: pointer;
	}
	#chatList #loading.message{
		display:none;
		background:rgb(33,74,102);
	}
	div.message.system{
		color: rgb(255, 186, 0);
		font-weight: bold;
	}
	img.typing{
		margin-left:3px;
	}
	img.delete {
		width:12px;
		height:12px;
		position:absolute;
		margin-left:360px;
		background:rgba(0,0,0,0.4);
		padding:1px;
		border-radius:3px;
	}
	img.delete:hover {
		background:rgba(0,0,0,1);
	}
</style>
 <!--
 <input type="submit" value="Добавить" />
 <input type="button" id="showMore" value="Показать старую переписку" />
-->
<script>
	function clearR(){
		$('.input').removeClass('success success2 fail fail2').removeAttr('disabled').val('Отправить');
		$('#inputChat').removeClass('success success2 fail fail2').removeAttr('disabled');
	}
	function preResult(d){
		if(d==2){var result='fail';}else{var result='success';}
		$('#inputChat').removeClass(result+'2').css('border-color','#F67118');
		$('.input').removeClass('success').val('Отправить');
	}
	function returnForm(d){
		if(d==2){var result='fail';}else{var result='success';}
		$('#inputChat').removeAttr('disabled').addClass(result+'2').val('');
		$('.input').removeAttr('disabled').addClass(result).val('Отправлено');
		setTimeout('preResult('+d+')',1000);
		$('#loading').css('opacity','0.6').delay(1000).slideUp(400);
	}
	function send(e){
		if(e.keyCode == 13 || e==0) {
			var message = $.trim($('#inputChat').val());
			if(message==''){
				$('.input').attr('disabled','disabled').val('Введ. собщ.');
				$('div.s1').stop(true,true).fadeIn(200).delay(1500).fadeOut(200);
			}
			else if(message.length<2){
				$('.input').attr('disabled','disabled').val('Введ. собщ.');
				$('div.s2').stop(true,true).fadeIn(200).delay(1500).fadeOut(200);
			}
			else{
			$('#loading').slideDown(400);
			$('#inputChat').attr('disabled','disabled').css('border-color','gray');
			$('.input').attr('disabled','disabled').val('Отправка...');
			$.post('/','d=chat_write&message='+message,function(data){
				if(data==1){
					$('.input').attr('disabled','disabled').val('Введ. собщ.');
					$('div.s2').stop(true,true).fadeIn(200).delay(1500).fadeOut(200);
					returnForm(2);setTimeout('clearR()',700);$('#loading').slideUp(300);
				}
				else if(data==4){
					$('#loading').hide();
					$('.input').attr('disabled','disabled').val('Измените собщ.');
					$('div.s4').stop(true,true).fadeIn(200).delay(1500).fadeOut(200);
					returnForm(2);
				}
				else if(data==2){
					$('.input').attr('disabled','disabled').val('Подождите 10 сек.');
					$('div.s3').stop(true,true).fadeIn(200).delay(1500).fadeOut(200);
					setTimeout("$('.input').removeAttr('disabled').val('Отправить');",10000)
					returnForm(2);setTimeout('clearR()',700);$('#loading').slideUp(300);
				}
				else if(data==3){
					upChat();
					returnForm();
				}
			});
			
			}
		}
	}
	function upChat(){
		$.post('/','d=on_chat');
		$('#chat').load('/account/chat/ #chat');
	}
	upChat();setInterval('upChat()',3000);
</script>
<div class="cl_rg color" style="margin-left:-13px;">
	<div class="cla_title">Пользовательский чат</div>
	<div id="box">    
		<div id="chat" style="margin-bottom:4px;">
			<div id="chatList">
			<?
			$messageList = $db->getAll("SELECT * FROM `$_chat` ORDER BY `id` DESC LIMIT 10");
			if(count($messageList)==0){?>
				<div class="message">
					<span class="date"><?=date("H:i")?></span>
					<span class="user" style="color:red;">System</span>
					<span class="text"> : Сообщений нет.</span>
				</div>
			<?}
			else{
				$messList=array();foreach($messageList as $m){$messList[$m['id']]=$m;}
				sort($messList);
				foreach($messList as $message){
					$text=$message['text'];$class='';
					$login_user=$message['login_user'];
					if($login_user=='admin'){$class.=' adm';}
					elseif($login_user==$u['login']){$class.=' i';}
					for($i=1;$i<=100;$i++){$text=str_replace(':sm'.$i.':','<img src="/smile/'.$i.'.gif" alt="sm'.$i.'">',$text);}
					?>
					<div class="message m<?=$message['id']?>">
					<?if($_SESSION['a']){?><img src="/img/delete.png" onClick="var d<?=$message['id']?>=setInterval('$(\'div.m<?=$message['id']?>\').css(\'opacity\',\'0.5\')',100);$.post('/','d=chat_delete&m=<?=$message['id']?>',function(data){if(data==1){$('div.m<?=$message['id']?>').slideUp(200);clearInterval(d<?=$message['id']?>);}});" class="delete"/><?}?>
					<span class="date<?=(time()-$message['date']>86400)?' old':''?>"><?=date("H:i",$message['date'])?></span>
					<span class="user<?=$class?>"<?=$_a?>><?=$login_user?></span>
					<span class="text"> : <?=$text?></span>
					</div>
				<?}
			}
			?>
			</div>
			<div id="onlineList">
				Кто онлайн
				<div id="whoOnlineList">
				<?
				$whoOnlineList = $db->getAll("SELECT `id`,`login`,`last_chat_activity` FROM `$_user` WHERE ".time()."-`last_chat`<60");
				//print_R($whoOnlineList);
				function show_online($_u,$db){$ul=gL($_SESSION['id'],$db);
					$_a='';$class='';
					if($_u['login']==$ul){$class=' class="i"';}
					if($_u['login']=='admin'){$_a=' onclick="user_modal('.$_u['id'].')" title="Редактировать" name="modal"';$class=' class="adm"';}
					$typing='';
					if(time()-$_u['last_chat_activity']<5){$typing='<img class="typing" src="/img/typing.gif"/>';}
					return '<li><a href="#dialog"'.$class.$_a.'>'.$_u['login'].'</a>'.$typing.'<br/></li>';
				}
				if(count($whoOnlineList)==0){echo show_online($u,$db);}
				else{foreach($whoOnlineList as $us){echo show_online($us,$db);}}?>
				</div>
			</div>
		</div>
			<div id="chatList" class="bottom">
				<div id="loading" class="message"><center><img src="/img/loading.gif"/></center></div>
				<div class="message system s1" style="display:none;"><center>Нельзя отправлять пустое сообщение !</center></div>
				<div class="message system s2" style="display:none;"><center>Слишком короткое сообщение !</center></div>
				<div class="message system s3" style="display:none;"><center>Нельзя слишком часто писать сообщения !</center></div>
				<div class="message system s4" style="display:none;"><center>Слишком длинное сообщение,<br/>длина не должна быть больше 200 символов !</center></div>
			</div>
        <form action="" method="post" id="chatForm" onsubmit="return false;">
			<input id="inputChat" type="text" class="messege" name="messege" maxlength="255" placeholder="Текст сообщения" onkeyup="send(event)">
			<div id="smileBlock" style="display:none;opacity:1;">
			<?for($i=1;$i<=100;$i++){?><img src="/smile/<?=$i?>.gif" alt=":sm<?=$i?>:"><?}?>
			</div>
			<img src="/img/smile.png" id="smile">
			 <input type="submit" style="height:47px;" class="input" onClick="send(0)" value="Отправить" />
		</form>
    </div>
<script type="text/javascript">
$(function(){
	var WRITE_STAMP=1;
	$("#smile").hover(function() {
		$("#smileBlock").stop().fadeIn(500);
	}, function() {
		$("#smileBlock").fadeOut(200);
	});
	$("#smileBlock").hover(function() {
		$("#smileBlock").stop().fadeIn(500);
	},function(){
		$("#smileBlock").fadeOut(200);
	});
	$("#smileBlock img").click(function() {
		$('#inputChat').val($('#inputChat').val()+$(this).attr("alt"));
	});
	$(document).on('input','#inputChat',function(){
		if($(this).val().length>=2){
			$('.input').removeAttr('disabled').val('Отправить');
			if($(this).val().length>=3){
				if(Math.round(new Date().getTime()/1000)-WRITE_STAMP>10){
					chat_activity();
				}
			}
		}
	});
});
</script>
</div>
<br/><br/><br/>